/*******************************************************************************
Copyright © 2023 Sebastian Roith <https://www.roith-unterrichtet.de>

Licensed under CC BY 4.0. To view a copy of this license, visit http://creativecommons.org/licenses/by/4.0/
*******************************************************************************/

window.CODINGTASK = {
	"heading": "Auftrag",
	"html": "<p>Die Klasse <code>SCHULKLASSE</code> soll den Umgang mit und das automatische Interpretieren von Schulklassenbezeichnungen wie <em>9a</em> oder <em>11d</em> erleichtern. Wie du siehst, wurde schon eine Klassendefinition programmiert. Ändere sie folgendermaßen ab bzw. berichtige sie:</p><ol><li><p>Der Parameter der Methode <code>getBezeichnung</code> wird gar nicht benötigt. Entferne ihn!</p></li><li><p>Der Rückgabewert-Datentyp der Methode <code>bezeichnungFestsetzen</code> ist falsch. Die Methode soll keinen Rückgabewert haben.</p></li><li><p>Bei der Methode <code>bezeichnungFestsetzen</code> wurde außerdem vergessen, die Ganzzahl <code>jgst</code> als Parameter zu deklarieren. Berichtige das! Der Datentyp des Parameters soll der des entsprechenden Attributs sein.</p></li><li><p>Ergänze eine Methode namens <code>wieLangeNoch</code>, die keinen Parameter hat, aber berechnet und zurück gibt, wie viele Jahre ein(e) Schüler(in) der Klasse noch regulär die Schule besucht. Der Rückgabewert muss also die Differenz aus <code>13</code> und dem Attributwert von <code>jahrgangsstufe</code> sein. Programmiere das in einer einzigen Anweisung.</p></li></ol>",
	"code": "class SCHULKLASSE {\n    int jahrgangsstufe;\n    char buchstabe;\n    \n    String getBezeichnung(boolean starteGross) {\n        return \"Klasse \"\n            + this.jahrgangsstufe\n            + this.buchstabe;\n    }\n    \n    int bezeichnungFestsetzen(char buchstabe) {\n        this.jahrgangsstufe = jgst;\n        this.buchstabe = buchstabe;\n    }\n}",
	"canReset": true,
	"labelSubmit": "📥 Klassendefinition überprüfen",
	"checkType": "json",
	"checkData": [
		{
			"part": "class",
			"name": "SCHULKLASSE",
			"extends": "Object",
			"implements": [],
			"abstract": false,
			"final": false,
			"static": false,
			"content": [
				{
					"part": "attribute",
					"name": "jahrgangsstufe",
					"type": "int",
					"dimensions": 0,
					"static": false
				},
				{
					"part": "attribute",
					"name": "buchstabe",
					"type": "char",
					"dimensions": 0,
					"static": false
				},
				{
					"part": "method",
					"name": "getBezeichnung",
					"type": "String",
					"params": [],
					"dimensions": 0,
					"static": false,
					"final": false,
					"abstract": false,
					"content": " return \"Klasse \" + this.jahrgangsstufe + this.buchstabe;"
				},
				{
					"part": "method",
					"name": "bezeichnungFestsetzen",
					"type": "void",
					"params": [
						[
							{
								"part": "variable",
								"name": "buchstabe",
								"type": "char",
								"dimensions": 0
							},
							{
								"part": "variable",
								"name": "jgst",
								"type": "int",
								"dimensions": 0
							}
						],
						[
							{
								"part": "variable",
								"name": "jgst",
								"type": "int",
								"dimensions": 0
							},
							{
								"part": "variable",
								"name": "buchstabe",
								"type": "char",
								"dimensions": 0
							}
						]
					],
					"dimensions": 0,
					"static": false,
					"final": false,
					"abstract": false,
					"content": " this.jahrgangsstufe = jgst;this.buchstabe = buchstabe;"
				},
				{
					"part": "method",
					"name": "wieLangeNoch",
					"type": [
						"int",
						"long",
						"short",
						"byte",
						"char",
						"float",
						"double"
					],
					"params": [],
					"dimensions": 0,
					"static": false,
					"final": false,
					"abstract": false,
					"content": [
						" return 13 - this.jahrgangsstufe;",
						" return 13 - jahrgangsstufe;"
					]
				}
			]
		}
	]
}
